﻿#pragma TextEncoding = "UTF-8"
#pragma rtGlobals=3
#pragma IgorVersion = 8
#pragma version = 1.00
#pragma hide=1

// loader for ProFilm images
Function imgTLoader_Profilm()

	string fList, theFile
	variable ic, nt, refNum
	
	NewPath/O/Q/M="Select a folder with Profilm files"/Z uIPath
	if (v_flag != 0)
		return -1
	endif
	flist = IndexedFile(uIPath,-1,".txt")
	nt = ItemsInList(flist)
	if (nt != 0)
		for (ic=0;ic<nt;ic+=1)
			theFile = StringFromList(ic, fList)
			read_PFtxt(theFile)
		endfor
	endif
	flist = IndexedFile(uIPath,-1,".sur")
	nt = ItemsInList(flist)
	if (nt != 0)
		for (ic=0;ic<nt;ic+=1)
			theFile = StringFromList(ic, fList)
			read_DSsurf(theFile)
		endfor
	endif
	
	return 0
end

// read in sur file format
Static Function read_DSsurf(string fileName)
	
	STRUCT DS_FileHeader dsh
	variable refNum, vmin
	string fName

	Open/R/P=uIPath refNum as fileName
	
	FBinRead refNum, dsh
	
	FStatus refNum
	variable TPoints = (v_logEOF-512)/4
	Make/O/I/U/N=(TPoints) DSImageWave
	FSetPos refNum, (512 + dsh.commentSize + dsh.privateSize)
	FBinRead/B=3/F=3 refNum, DSImageWave
	wave DSImageWave
	Close refNum
	
	variable xyaspect, Nx, Ny
	xyAspect = dsh.xPoints/dsh.yPoints
	Nx = round(sqrt(xyAspect*TPoints))
	Ny = round(TPoints/Nx)
	Duplicate/O DSImageWave img_src
	Redimension/N=(Nx,Ny) img_src
	vmin = WaveMin(img_src)
	fName = CleanUpName(RemoveEnding(fileName,".sur"),0)+"sur"
	MatrixOP/O $fName = fp64(img_src - vmin)
	Killwaves/Z DSImageWave, img_src
	return 0
end

// read ProFilm text format image
Static Function read_PFtxt(string fileName)

	string iStr, hstr, fName
	variable refNum, vmin
	
	Open/R/P=uIPath refNum as fileName
	FReadLine refNum, iStr
	FReadLine refNum, iStr
	hstr = iStr
	Close refNum
	LoadWave/J/M/D/N=imgL/O/K=1/V={"\t"," $",0,0}/L={0,3,0,0,0}/P=uIPath/Q fileName
	wave imgL0
	vmin = WaveMin(imgL0)
	fName = CleanUpName(RemoveEnding(fileName,".txt"),0)
	MatrixOP/O $fName = ((imgL0^t) - vmin)*1E3
	KillWaves imgL0
	Note $fName, hstr
	return 0
end

// header structure for Digital Surf image files
Structure DS_FileHeader

	char signature[12]
	uint16 format
	uint16 objNum
	uint16 version
	uint16 objType
	char objName[30]
	char operatorName[30]
	uint16 mCode
	uint16 aType
	uint16 rType
	uint16 spPoints
	uint16 aHeights
	uint16 gResolution
	char rSpace[4]
	uint16 soPoints
	uint32 zMin
	uint32 zMax
	uint32 xPoints
	uint32 yPoints
	uint32 TPoints
	float xSpacing
	float ySpacing
	float zSpacing
	char xName[16]
	char yName[16]
	char zName[16]
	char xStepUnit[16]
	char yStepUnit[16]
	char zStepUnit[16]
	char xLengthUnit[16]
	char yLengthUnit[16]
	char zLengthUnit[16]
	float xUnitRatio
	float yUnitRatio
	float zUnitRatio
	uint16 imprint
	uint16 inverted
	uint16 levelled
	char obsoleteA[12]
	uint16 startsecs
	uint16 startmins
	uint16 starthrs
	uint16 startmon
	uint16 startyr
	uint16 startwkday
	float measureDuration
	char obsoleteB[10]
	uint16 commentSize
	uint16 privateSize
	char clientZone[128]
	float xOffset
	float yOffset
	float zOffset
	float TSpacing
	float TOffset
	char TStepUnit[13]
	char TAxisName[13]
	
EndStructure

// image structures for Digital Surf image files
Structure DS_FileImage16
	uint16 points
EndStructure

Structure DS_FileImage32
	uint32 points
EndStructure
